unit Unit1;
//Made according to the protocol described in "Protocol to export a position toward the DDE OMMap server.pdf"
interface

{After having started OMMap, click successively on the buttons:
 * Connection to the OMMap server
 * Build the position frame and display it.
 * Transmitting_the_position_frame}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DdeMan, StdCtrls;

type
  TForm1 = class(TForm)
    DdeClientConv_OMMap: TDdeClientConv;
    DdeClientItem_OMMap: TDdeClientItem;
    Edit1: TEdit;
    Label2: TLabel;
    Transmitting_the_position_frame: TButton;
    Connection_to_the_OMMap_server: TButton;
    Building_the_position_frame: TButton;
    Label1: TLabel;
    Disconnexion: TButton;
    procedure Transmitting_the_position_frameClick(Sender: TObject);
    procedure Connection_to_the_OMMap_serverClick(Sender: TObject);
    procedure Building_the_position_frameClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DdeClientConv_OMMapClose(Sender: TObject);
    procedure DisconnexionClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

VAR CONNECTED_TO_THE_SERVER:BOOLEAN;

{************}

procedure TForm1.Connection_to_the_OMMap_serverClick(Sender: TObject);
var AppHandle:THandle;
begin
  {If OMMap is not started, manually first start it. In the contrary case, OMMap would be started automatically by Openlink
   (if OMMap is in the same directory), which is not desirable}
  AppHandle:=FindWindow(Nil, PCHAR('OMMap'));//OMMap started?
  IF AppHandle=0 THEN//OMMap not started
  BEGIN
   CONNECTED_TO_THE_SERVER:=FALSE;
   Label2.Caption:='First manually start OMMap.exe!';
  END ELSE //OMMap started
  BEGIN
   Form1.DDEClientConv_OMMAP.Setlink('OMMap','DDEServer_OMMAP');
   IF Form1.DDEClientConv_OMMap.OpenLink=FALSE THEN
   BEGIN
    CONNECTED_TO_THE_SERVER:=FALSE;
    Label2.Caption:='DDE link closed with the OMMap server';
   END ELSE
   BEGIN
    CONNECTED_TO_THE_SERVER:=TRUE;
    Label2.Caption:='DDE link open with the OMMap server';
   END;
  END;
end;

{**********}

procedure TForm1.DisconnexionClick(Sender: TObject);
begin
  Form1.DDEClientConv_OMMap.CloseLink;
  CONNECTED_TO_THE_SERVER:=FALSE;
  Label2.Caption:='DDE link closed with the OMMap server';
end;

{************}

procedure TForm1.DdeClientConv_OMMapClose(Sender: TObject);
begin
 CONNECTED_TO_THE_SERVER:=FALSE;
 Label2.Caption:='DDE link closed with the OMMap server';
end;

{*************}

PROCEDURE REMOVAL_OF_INITIAL_AND_FINAL_SPACES(VAR CHAINE:STRING);
VAR TAMPON:STRING;
VAR COMPTEUR,POSITION,NOMBRE:LONGINT;
VAR CARACTERE:CHAR;
BEGIN
 {on passe les premiers espaces}
 POSITION:=1; {initialisation}
 FOR COMPTEUR:=1 TO LENGTH(CHAINE) DO
 BEGIN
  CARACTERE:=CHAINE[COMPTEUR];
   IF CARACTERE=' ' THEN POSITION:=COMPTEUR+1 {on passe} ELSE BREAK;{on a termin}
 END;

 {on note le nombre d'espaces finaux contigus}
 NOMBRE:=0;{initialisation}
 FOR COMPTEUR:=LENGTH(CHAINE) DOWNTO POSITION DO
 BEGIN
  CARACTERE:=CHAINE[COMPTEUR];
  IF CARACTERE=' ' THEN INC(NOMBRE)
  ELSE BREAK;{on a termin}
 END;

 {on extrait la chane sans espaces premiers et finaux}
 TAMPON:='';{initialisation}
 FOR COMPTEUR:=POSITION TO LENGTH(CHAINE)-NOMBRE DO
 BEGIN
  CARACTERE:=CHAINE[COMPTEUR];
  TAMPON:=TAMPON+CARACTERE;
 END;
 CHAINE:=TAMPON;
END;

{*************}

PROCEDURE REPLACEMENT_OF_A_CHARACTER_BY_ANOTHER_CHARACTER(VAR CHAINE:STRING;CARACTERE:CHAR;AUTRE_CARACTERE:CHAR);
{dans une chaine, on remplace les caractres CARACTERE par AUTRE_CARACTERE}
VAR COMPTEUR:LONGINT;
BEGIN
 FOR COMPTEUR:=1 TO LENGTH(CHAINE) DO
 BEGIN
  IF CHAINE[COMPTEUR]=CARACTERE THEN CHAINE[COMPTEUR]:=AUTRE_CARACTERE;
 END;
END;


{**********}

FUNCTION TRANSFORMATION_DECIMAL_HEXA(NOMBRE:LONGINT):STRING;
{transforme un nombre dcimal de 2E9 max (exemple '171',  en Hexa ('AB' ici)}
VAR COMPTEUR:BYTE;
VAR CHAINE:STRING;
VAR MODULO,DIVISE:LONGINT;
VAR CARACTERE:CHAR;
BEGIN
 CHAINE:='';
 FOR COMPTEUR:=1 TO 8 DO
 BEGIN
  MODULO:=NOMBRE MOD 16;
  IF MODULO<=9 THEN CARACTERE:=CHR(MODULO+48) ELSE
  IF MODULO=10 THEN CARACTERE:='A' ELSE
  IF MODULO=11 THEN CARACTERE:='B' ELSE
  IF MODULO=12 THEN CARACTERE:='C' ELSE
  IF MODULO=13 THEN CARACTERE:='D' ELSE
  IF MODULO=14 THEN CARACTERE:='E' ELSE
  IF MODULO=15 THEN CARACTERE:='F';
  CHAINE:=CARACTERE+CHAINE;
  DIVISE:=NOMBRE DIV 16;
  IF DIVISE=0 THEN BREAK ELSE NOMBRE:=DIVISE;
 END;
 TRANSFORMATION_DECIMAL_HEXA:=CHAINE;
END;

{***********}

FUNCTION FRAME_CRC(RECU:STRING):STRING;
VAR COMPTEUR,CODE:BYTE;
VAR CRC:STRING;
begin
 CODE:=0;
 FOR COMPTEUR:=1 TO LENGTH(RECU) DO
 BEGIN
  CODE:=CODE XOR (ORD(RECU[COMPTEUR]));
 END;
 CRC:=TRANSFORMATION_DECIMAL_HEXA(CODE);
 IF CODE<=15 THEN CRC:='0'+CRC;
 FRAME_CRC:=CRC;
end;

{************}

procedure TForm1.Building_the_position_frameClick(Sender: TObject);
VAR LATITUDE,LONGITUDE:DOUBLE;
VAR FRAME,IDENTIFIER,TYPE_OF_VEHICLE,LAT,LONG,DIGITAL_MODE,CRC:STRING;
begin
 {Example}
 LATITUDE:=-34.25; LONGITUDE:=123.45678;
 IDENTIFIER:='AB CD'; TYPE_OF_VEHICLE:='A';
 DIGITAL_MODE:='ACARS';

 {building of the frame}
 STR(LATITUDE:9:5,LAT); REMOVAL_OF_INITIAL_AND_FINAL_SPACES(LAT);
 STR(LONGITUDE:10:5,LONG); REMOVAL_OF_INITIAL_AND_FINAL_SPACES(LONG);

 REMOVAL_OF_INITIAL_AND_FINAL_SPACES(IDENTIFIER);
 REPLACEMENT_OF_A_CHARACTER_BY_ANOTHER_CHARACTER(IDENTIFIER,' ','_');
 IF IDENTIFIER='' THEN IDENTIFIER:='_';//No identifier or call sign
 IF LENGTH(IDENTIFIER)>20 THEN EXIT;//The identifier is too long

 REMOVAL_OF_INITIAL_AND_FINAL_SPACES(TYPE_OF_VEHICLE);
 IF TYPE_OF_VEHICLE='' THEN TYPE_OF_VEHICLE:='_';//No type of vehicle
 IF (TYPE_OF_VEHICLE<>'A') AND (TYPE_OF_VEHICLE<>'B') AND (TYPE_OF_VEHICLE<>'E') AND (TYPE_OF_VEHICLE<>'G') AND (TYPE_OF_VEHICLE<>'T') AND
    (TYPE_OF_VEHICLE<>'M') AND (TYPE_OF_VEHICLE<>'S') AND (TYPE_OF_VEHICLE<>'C') AND (TYPE_OF_VEHICLE<>'H') AND (TYPE_OF_VEHICLE<>'L') AND
    (TYPE_OF_VEHICLE<>'_') THEN EXIT;//Incorrect TYPE_OF_VEHICLE

 REMOVAL_OF_INITIAL_AND_FINAL_SPACES(DIGITAL_MODE);
 REPLACEMENT_OF_A_CHARACTER_BY_ANOTHER_CHARACTER(DIGITAL_MODE,' ','_');
 IF DIGITAL_MODE='' THEN DIGITAL_MODE:='_';//No digital mode
 IF LENGTH(DIGITAL_MODE)>10 THEN EXIT;//The digital mode is too long

 //'0' for protocol version 0
 FRAME:='0'+' '+LAT+' '+LONG+' '+IDENTIFIER+' '+TYPE_OF_VEHICLE+' '+DIGITAL_MODE;
 CRC:=FRAME_CRC(FRAME);
 FRAME:=FRAME+' '+CRC;
 Edit1.Text:=FRAME;
end;

{************}

procedure TForm1.Transmitting_the_position_frameClick(Sender: TObject);
VAR COMMAND:ARRAY[0..255] of CHAR;//limited to 255 characters
VAR FRAME:STRING;
VAR SUCCESS:BOOLEAN;
begin
 FRAME:=Edit1.TEXT;
 IF FRAME='' THEN
 BEGIN
  MessageDlg('No frame to send',mtError,[mbOK],0);
  EXIT;
 END;
 IF CONNECTED_TO_THE_SERVER=FALSE THEN
 BEGIN
  MessageDlg('Not connected to the server',mtError,[mbOK],0);
  EXIT;
 END;
 StrPCopy(COMMAND,FRAME);
 SUCCESS:=DDEClientConv_OMMap.ExecuteMacro(COMMAND,FALSE);
 IF SUCCESS=TRUE THEN Label1.Caption:='Success to transmit the frame' ELSE Label1.Caption:='Failure to transmit the frame';
end;

{************}

procedure TForm1.FormActivate(Sender: TObject);
begin
 CONNECTED_TO_THE_SERVER:=FALSE;
end;



end.
